# -*- coding: utf-8 -*-
# Author: allen
# Copyright (c) 2020 RuiCare All rights reserved.
import json
import os
import sys
import time
from collections import OrderedDict

from util import fileutil

config = None
dir_name, file_name = os.path.split(os.path.abspath(sys.argv[0]))


def get_config(raiseerror=True, block_on_error=False):
    global config
    if config is None:
        try:
            config_str = fileutil.load("%s/config/config.json" % dir_name)
            config = json.loads(config_str, object_pairs_hook=OrderedDict)
        except Exception as e:
            if raiseerror:
                raise e
            else:
                print('Load config catch error:%s, please check config.' % e)
            if block_on_error:
                time.sleep(1000000)
    return config


def get_dir():
    return dir_name
