# -*- coding: utf-8 -*-
# Author: allen
# Copyright (c) 2020 RuiCare All rights reserved.
import json
import os
import xlwt
from core import configer
from util import dcmutil, fileutil

config = configer.get_config(False, True)
dcm_dir = config.get('DcmDir')
roi_name_affix = config.get('RoiNameAffix')


def get_roi_names(pat_dir):
    rs_dcm_data, _ = dcmutil.get_newest_rs(pat_dir)
    if rs_dcm_data is None: return []
    return list(dcmutil.get_roi_info(rs_dcm_data).keys())


def is_contain_roi(label_name, roi_config):
    contains = roi_config.get('Contains')
    is_contain = False
    for contain in contains:
        if label_name.lower().__contains__(contain): is_contain = True
    return is_contain


def start():
    rois = {}
    pat_dir_names = fileutil.list_dir_name(dcm_dir)
    pat_dir_names.sort()

    for index, pat_dir_name in enumerate(pat_dir_names):

        pat_dir = os.path.join(dcm_dir, pat_dir_name)
        roi_names = []
        try:
            roi_names = get_roi_names(pat_dir)
        except Exception as e:
            print('Extracting roi names %s catch error:%s' % (pat_dir, e))

        for roi_name in roi_names:
            if not rois.get(roi_name): rois[roi_name] = []
            if not rois[roi_name].__contains__(pat_dir_name): rois[roi_name].append(pat_dir_name)

        print(index, pat_dir_name)

    workbook = xlwt.Workbook(encoding='utf-8')
    fileutil.write('./UNIQUE_ROIS.json', json.dumps({"UNIQUE_ROIS": rois}))
    for index, roi_name in enumerate(rois.keys()):
        pat_ids = rois.get(roi_name)
        if len(pat_ids) < 10: continue
        worksheet = workbook.add_sheet(f'{index}_{roi_name}')

        for index, pat_id in enumerate(pat_ids):
            new_pat_id = f'00010008{str(index + 1).zfill(4)}'
            worksheet.write(index, 0, label=pat_id)
            worksheet.write(index, 1, label=new_pat_id)

    workbook.save('%s/resource/ROIS.xls' % configer.get_dir())
